//+------------------------------------------------------------------+
//|                                                       Proba9.mq4 |
//|                                                          Vitalik |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Vitalik"
#property link      "http://www.metaquotes.net"

#property indicator_level1 0.0
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property  indicator_width1 2
#property indicator_color2 Red
#property  indicator_width2 2
#property indicator_color3 Blue
 
 //           Close   .
 //         -   20   
 //         - SMA 9  . 
 //     
 //        , ,      20  9.
 //                                             .
extern int MA_Period=1;
extern int MA_Period2=2;
extern int CountK=19;
extern int CountN= 9;


double ExtMapBuffer[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
int ExtCountedBars=0;

int init()
  {
  
 
   SetIndexBuffer(0,ExtMapBuffer);
    SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(1,ExtMapBuffer1);
    SetIndexStyle(1,DRAW_LINE);
     SetIndexBuffer(2,ExtMapBuffer2);
    SetIndexStyle(2,DRAW_LINE);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  { double sum=0,Itog;
   int    i,pos=Bars-ExtCountedBars-1;
//---- initial accumulation
   if(pos<MA_Period) pos=MA_Period;
   for(i=1;i<MA_Period;i++,pos--)
      sum+=Close[pos];
//---- main calculation loop
   while(pos>=0) {
      sum+=Close[pos];
      Itog=sum-Close[pos+1];
      ExtMapBuffer[pos]=Itog;
      
      ExtMapBuffer1[pos]=0;
      for (int k=0;k<CountK;k++) ExtMapBuffer1[pos]+=  ExtMapBuffer[pos+k+1];
      ExtMapBuffer1[pos]+=Itog;

      ExtMapBuffer2[pos]=0;
      for (int n=0;n<CountN;n++) ExtMapBuffer2[pos]+=ExtMapBuffer1[pos+n];
      ExtMapBuffer2[pos]/=(CountN*1.0);
 
	   sum-=Close[pos+MA_Period-1];
	  
 	   pos--;
     }
 
   return(0);
  }
//+------------------------------------------------------------------+